﻿Option Strict On
Option Explicit On

Imports System.IO.MemoryMappedFiles
Imports System.Text
Imports System.Xml.Serialization
Imports System.IO

'This Example was Created by Dustin Arrell (aka - yobuddy on the XSimulator forums) 
'Use MyMMFData.Axis 1-6 to get the current data needed for your output
'All SimTools connectivity is completed in this example

Public Class Form1
#Region " Variables"
    'Set Your Options
    Private filename As String = "SimTools_Example" 'add to the file name as needed
    Private Const msRate As Integer = 10
    Private Const DefaultValue As String = "0"

    'Needed Vars
    Delegate Sub SetTextCallback([text] As String)
    Private ThreadReceive As System.Threading.Thread
    Private mmf As MemoryMappedFile
    Private MyMMFData As New MMFData

    'the main structure to hold the incomming data.
    Public Structure MMFData
        Public _Axis1a As String
        Public _Axis2a As String
        Public _Axis3a As String
        Public _Axis4a As String
        Public _Axis5a As String
        Public _Axis6a As String
        Public _Axis1b As String
        Public _Axis2b As String
        Public _Axis3b As String
        Public _Axis4b As String
        Public _Axis5b As String
        Public _Axis6b As String
        Public Property Axis1a() As String
            Get
                Return _Axis1a
            End Get
            Set(value As String)
                _Axis1a = value
            End Set
        End Property
        Public Property Axis2a() As String
            Get
                Return _Axis2a
            End Get
            Set(value As String)
                _Axis2a = value
            End Set
        End Property
        Public Property Axis3a() As String
            Get
                Return _Axis3a
            End Get
            Set(value As String)
                _Axis3a = value
            End Set
        End Property
        Public Property Axis4a() As String
            Get
                Return _Axis4a
            End Get
            Set(value As String)
                _Axis4a = value
            End Set
        End Property
        Public Property Axis5a() As String
            Get
                Return _Axis5a
            End Get
            Set(value As String)
                _Axis5a = value
            End Set
        End Property
        Public Property Axis6a() As String
            Get
                Return _Axis6a
            End Get
            Set(value As String)
                _Axis6a = value
            End Set
        End Property
        Public Property Axis1b() As String
            Get
                Return _Axis1b
            End Get
            Set(value As String)
                _Axis1b = value
            End Set
        End Property
        Public Property Axis2b() As String
            Get
                Return _Axis2b
            End Get
            Set(value As String)
                _Axis2b = value
            End Set
        End Property
        Public Property Axis3b() As String
            Get
                Return _Axis3b
            End Get
            Set(value As String)
                _Axis3b = value
            End Set
        End Property
        Public Property Axis4b() As String
            Get
                Return _Axis4b
            End Get
            Set(value As String)
                _Axis4b = value
            End Set
        End Property
        Public Property Axis5b() As String
            Get
                Return _Axis5b
            End Get
            Set(value As String)
                _Axis5b = value
            End Set
        End Property
        Public Property Axis6b() As String
            Get
                Return _Axis6b
            End Get
            Set(value As String)
                _Axis6b = value
            End Set
        End Property
    End Structure
#End Region

#Region "Get and Set DATA"
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'start looking for data
        ThreadReceive = New System.Threading.Thread(AddressOf GetDataLoop)
        ThreadReceive.IsBackground = True
        ThreadReceive.Start()
    End Sub

    Public Sub GetDataLoop()
        'loop forever
        Do While 1 = 1
            'Look for a mmf file
            GetData()

            'can be removed for speed if needed
            System.Threading.Thread.Sleep(msRate)
        Loop
    End Sub

    Public Sub GetData()
        Try
            mmf = MemoryMappedFile.OpenExisting(filename, MemoryMappedFileRights.FullControl)
            Dim accessor As MemoryMappedViewAccessor = mmf.CreateViewAccessor()
            Dim Size As UShort = accessor.ReadUInt16(0)
            Dim Buffer As Byte() = New Byte(Size - 1) {}
            accessor.ReadArray(0, Buffer, 0, Buffer.Length)
            accessor.Dispose()
            Dim output As String = ASCIIEncoding.ASCII.GetString(Buffer).ToString
            Dim ParsedOutput() As String = output.Split(CChar(","))

            'set output screen - optional
            MyMMFData.Axis1a = ParsedOutput(0)
            MyMMFData.Axis2a = ParsedOutput(1)
            MyMMFData.Axis3a = ParsedOutput(2)
            MyMMFData.Axis4a = ParsedOutput(3)
            MyMMFData.Axis5a = ParsedOutput(4)
            MyMMFData.Axis6a = ParsedOutput(5)
            MyMMFData.Axis1b = ParsedOutput(6)
            MyMMFData.Axis2b = ParsedOutput(7)
            MyMMFData.Axis3b = ParsedOutput(8)
            MyMMFData.Axis4b = ParsedOutput(9)
            MyMMFData.Axis5b = ParsedOutput(10)
            MyMMFData.Axis6b = ParsedOutput(11)
            SetText_Axis1a(ParsedOutput(0))
            SetText_Axis2a(ParsedOutput(1))
            SetText_Axis3a(ParsedOutput(2))
            SetText_Axis4a(ParsedOutput(3))
            SetText_Axis5a(ParsedOutput(4))
            SetText_Axis6a(ParsedOutput(5))
            SetText_Axis1b(ParsedOutput(6))
            SetText_Axis2b(ParsedOutput(7))
            SetText_Axis3b(ParsedOutput(8))
            SetText_Axis4b(ParsedOutput(9))
            SetText_Axis5b(ParsedOutput(10))
            SetText_Axis6b(ParsedOutput(11))
        Catch ex As Exception
            'do notta - memory map not made yet?
            MyMMFData.Axis1a = DefaultValue
            MyMMFData.Axis2a = DefaultValue
            MyMMFData.Axis3a = DefaultValue
            MyMMFData.Axis4a = DefaultValue
            MyMMFData.Axis5a = DefaultValue
            MyMMFData.Axis6a = DefaultValue
            MyMMFData.Axis1b = DefaultValue
            MyMMFData.Axis2b = DefaultValue
            MyMMFData.Axis3b = DefaultValue
            MyMMFData.Axis4b = DefaultValue
            MyMMFData.Axis5b = DefaultValue
            MyMMFData.Axis6b = DefaultValue
            SetText_Axis1a(DefaultValue)
            SetText_Axis2a(DefaultValue)
            SetText_Axis3a(DefaultValue)
            SetText_Axis4a(DefaultValue)
            SetText_Axis5a(DefaultValue)
            SetText_Axis6a(DefaultValue)
            SetText_Axis1b(DefaultValue)
            SetText_Axis2b(DefaultValue)
            SetText_Axis3b(DefaultValue)
            SetText_Axis4b(DefaultValue)
            SetText_Axis5b(DefaultValue)
            SetText_Axis6b(DefaultValue)
        End Try
    End Sub
#End Region

#Region " Set Text to Form"
    Private Sub SetText_Axis1a(ByVal [text] As String)
        Try
            'Axis1
            If txt_Axis1a.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis1a)
                Invoke(d, New Object() {text})
            Else
                txt_Axis1a.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis2a(ByVal [text] As String)
        Try
            'Axis2
            If txt_Axis1a.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis2a)
                Invoke(d, New Object() {text})
            Else
                txt_Axis2a.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis3a(ByVal [text] As String)
        Try
            'Axis3
            If txt_Axis1a.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis3a)
                Invoke(d, New Object() {text})
            Else
                txt_Axis3a.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis4a(ByVal [text] As String)
        Try
            'Axis4
            If txt_Axis1a.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis4a)
                Invoke(d, New Object() {text})
            Else
                txt_Axis4a.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis5a(ByVal [text] As String)
        Try
            'Axis5
            If txt_Axis1a.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis5a)
                Invoke(d, New Object() {text})
            Else
                txt_Axis5a.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis6a(ByVal [text] As String)
        Try
            'Axis6
            If txt_Axis1a.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis6a)
                Invoke(d, New Object() {text})
            Else
                txt_Axis6a.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis1b(ByVal [text] As String)
        Try
            'Axis1
            If txt_Axis1b.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis1b)
                Invoke(d, New Object() {text})
            Else
                txt_Axis1b.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis2b(ByVal [text] As String)
        Try
            'Axis2
            If txt_Axis1b.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis2b)
                Invoke(d, New Object() {text})
            Else
                txt_Axis2b.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis3b(ByVal [text] As String)
        Try
            'Axis3
            If txt_Axis1b.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis3b)
                Invoke(d, New Object() {text})
            Else
                txt_Axis3b.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis4b(ByVal [text] As String)
        Try
            'Axis4
            If txt_Axis1b.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis4b)
                Invoke(d, New Object() {text})
            Else
                txt_Axis4b.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis5b(ByVal [text] As String)
        Try
            'Axis5
            If txt_Axis1b.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis5b)
                Invoke(d, New Object() {text})
            Else
                txt_Axis5b.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub

    Private Sub SetText_Axis6b(ByVal [text] As String)
        Try
            'Axis6
            If txt_Axis1b.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetText_Axis6b)
                Invoke(d, New Object() {text})
            Else
                txt_Axis6b.Text = [text]
            End If
        Catch ex As Exception
            'form closing?
        End Try
    End Sub
#End Region
End Class
